<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwInstallation: fwInstallationProjParam.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwInstallation
   &#160;<span id="projectnumber">8.4.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">fwInstallationProjParam.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:aec01491e4e8821689172ab6707a97639"><td class="memItemLeft" align="right" valign="top">private string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#aec01491e4e8821689172ab6707a97639">fwInstallationProjParam_getParamName</a> (string key, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE)</td></tr>
<tr class="separator:aec01491e4e8821689172ab6707a97639"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af56916bffc5496d98fbbab9d3b664f53"><td class="memItemLeft" align="right" valign="top">private string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#af56916bffc5496d98fbbab9d3b664f53">fwInstallationProjParam_extractKeyFromParamName</a> (string paramName)</td></tr>
<tr class="separator:af56916bffc5496d98fbbab9d3b664f53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5706ce1ae9ff5d569154a785a71502b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#ab5706ce1ae9ff5d569154a785a71502b">fwInstallationProjParam_keyExists</a> (string key, bool &amp;exists, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE)</td></tr>
<tr class="separator:ab5706ce1ae9ff5d569154a785a71502b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af547b9808c9ab80ae81356b36846c5e9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#af547b9808c9ab80ae81356b36846c5e9">fwInstallationProjParam_registerKey</a> (string key, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string dataType=<a class="el" href="fwInstallationProjParam_8ctl.html#a9c246f46e4f1f099cfc5336595d09357">FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE</a>, string description=&quot;&quot;, string family=&quot;&quot;)</td></tr>
<tr class="separator:af547b9808c9ab80ae81356b36846c5e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee844f5d9d2c06604a03a6e5dcc6206c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#aee844f5d9d2c06604a03a6e5dcc6206c">fwInstallationProjParam_removeKey</a> (string key, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE)</td></tr>
<tr class="separator:aee844f5d9d2c06604a03a6e5dcc6206c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6896e0e260f1e4880535340c403c0787"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#a6896e0e260f1e4880535340c403c0787">fwInstallationProjParam_valueExists</a> (string key, bool &amp;exists, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string project=&quot;&quot;, string host=&quot;&quot;)</td></tr>
<tr class="separator:a6896e0e260f1e4880535340c403c0787"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3510b799f949d51a1350b8bd9db3aaa7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#a3510b799f949d51a1350b8bd9db3aaa7">fwInstallationProjParam_registerKeyValue</a> (string key, string value, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string dataType=<a class="el" href="fwInstallationProjParam_8ctl.html#a9c246f46e4f1f099cfc5336595d09357">FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE</a>, string description=&quot;&quot;, string family=&quot;&quot;, string project=&quot;&quot;, string host=&quot;&quot;)</td></tr>
<tr class="separator:a3510b799f949d51a1350b8bd9db3aaa7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7e21f7c42a22cccbd1f4b4c298310f72"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#a7e21f7c42a22cccbd1f4b4c298310f72">fwInstallationProjParam_setValue</a> (string key, string value, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string project=&quot;&quot;, string host=&quot;&quot;)</td></tr>
<tr class="separator:a7e21f7c42a22cccbd1f4b4c298310f72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61bc7b05fe92e9354b0dea24778d4833"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#a61bc7b05fe92e9354b0dea24778d4833">fwInstallationProjParam_getValue</a> (string key, string &amp;value, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string project=&quot;&quot;, string host=&quot;&quot;)</td></tr>
<tr class="separator:a61bc7b05fe92e9354b0dea24778d4833"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab302557f31c4ea8606e2459371c50c23"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#ab302557f31c4ea8606e2459371c50c23">fwInstallationProjParam_removeValue</a> (string key, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string project=&quot;&quot;, string host=&quot;&quot;)</td></tr>
<tr class="separator:ab302557f31c4ea8606e2459371c50c23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac62b333430ebe3571006594cd4786834"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#ac62b333430ebe3571006594cd4786834">fwInstallationProjParam_getKeyValueMapping</a> (mapping &amp;keyValMapping, string namespace=FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE, string project=&quot;&quot;, string host=&quot;&quot;)</td></tr>
<tr class="separator:ac62b333430ebe3571006594cd4786834"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a8032f461023707ce5c927fcb96c36936"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#a8032f461023707ce5c927fcb96c36936">csFwInstallationProjParamLibVersion</a> = &quot;8.4.2&quot;</td></tr>
<tr class="separator:a8032f461023707ce5c927fcb96c36936"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c246f46e4f1f099cfc5336595d09357"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9c246f46e4f1f099cfc5336595d09357"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationProjParam_8ctl.html#a9c246f46e4f1f099cfc5336595d09357">FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE</a> = &quot;text/plain&quot;</td></tr>
<tr class="memdesc:a9c246f46e4f1f099cfc5336595d09357"><td class="mdescLeft">&#160;</td><td class="mdescRight">type/storage-type, other examples: test/encrypted, password/encrypted, etc. <br/></td></tr>
<tr class="separator:a9c246f46e4f1f099cfc5336595d09357"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This library contains functions to store and read project-specific parameters from DB (ConfigurationDBSystemInformation). Project parameter's value is stored under the specified namespace and key. Internally, inside the DB, "parameter name" is used which combines key and namespace into one identifier. Existence of namespaces is to allow same keynames to exists. For each project and parameter name (namespace-key pair) one project parameter value can exists.</p>
<p>User can register its own keys and namespaces. The key can be freely named although it is not recommended to use special characters (underscore and dash are allowed). The default namespace exists however it is advised to use the unique name to avoid repetitions of parameter name. It is suggested to use, as the namespace, the name of the component that uses this library to store its parameters. This guarantees the unique namespaces for each component and makes the the developer of the component responsible for keeping the unique key names only. For namespace name it is forbidden to use slash '/' as it is used as namespace-key separator. For other characters the same restrictions as for key name are applied.</p>
<p>Usage: Before first usage of the key it has to be registered. There are 2 functions that allow it: <a class="el" href="fwInstallationProjParam_8ctl.html#af547b9808c9ab80ae81356b36846c5e9">fwInstallationProjParam_registerKey()</a> and <a class="el" href="fwInstallationProjParam_8ctl.html#a3510b799f949d51a1350b8bd9db3aaa7">fwInstallationProjParam_registerKeyValue()</a>. The first one only registers the key with given properties in provided namespace with no value assigned. The second one allows also to register a value for specified project in one go. Both functions returns success if key is already registered (they do not change key's properties), so there is no need to check before if key is already registered.</p>
<p>int retVal = fwInstallationProjParam_registerKey("myKey", "fwInstallation", FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE, "This is my dummy key"); or int retVal = fwInstallationProjParam_registerKeyValue("myKey", "myValue", "fwInstallation", FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE, "This is my dummy key");</p>
<p>To register a value or to change already set value for a given key, namespace and project, a <a class="el" href="fwInstallationProjParam_8ctl.html#a7e21f7c42a22cccbd1f4b4c298310f72">fwInstallationProjParam_setValue()</a> function can be used.</p>
<p>// Assuming at this moment that key is already registered so it is not neccessary to check it, if this assumption // is wrong then error code is assigned to retVal int retVal = fwInstallationProjParam_setValue("myKey", "myValue", "fwInstallation");</p>
<p>To get value for a given key, namespace and project use <a class="el" href="fwInstallationProjParam_8ctl.html#a61bc7b05fe92e9354b0dea24778d4833">fwInstallationProjParam_getValue()</a>. In case a requested key doesn't exists - function will return an error (there's a function to check existence of a key).</p>
<p>bool exists = false; string value; int retVal1 = fwInstallationProjParam_valueExists("myKey", exists, "fwInstallation"); if(exists &amp;&amp; !retVal1) int retVal2 = fwInstallationProjParam_getValue("myKey", value, "fwInstallation");</p>
<p>To get all registered key - value pairs for given namespace and project one can use <a class="el" href="fwInstallationProjParam_8ctl.html#ac62b333430ebe3571006594cd4786834">fwInstallationProjParam_getKeyValueMapping()</a> function. Registered key - value pairs are returned as a mapping.</p>
<p>mapping keyValMapping; int retVal = fwInstallationProjParam_getKeyValueMapping(keyValMapping, "fwInstallation");</p>
<p>Note: "fwInstallation" in examples above should be replaced by the name of component that uses these functions. </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="aec01491e4e8821689172ab6707a97639"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private string fwInstallationProjParam_getParamName </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the parameter name from provided key and namespace </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Name of the key </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Name of the namespace </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>parameter name: "namespace/key" </dd></dl>

</div>
</div>
<a class="anchor" id="af56916bffc5496d98fbbab9d3b664f53"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private string fwInstallationProjParam_extractKeyFromParamName </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>paramName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns key extracted from parameter name </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">paramName</td><td>(in) Parameter name </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Key name or empty string in case the paramName has wrong pattern </dd></dl>

</div>
</div>
<a class="anchor" id="ab5706ce1ae9ff5d569154a785a71502b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_keyExists </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>exists</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if given parameter name (key - namespace pair) is already registered in DB. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">exists</td><td>(out) Flag that indicates if a parameter exists in DB, note: this flag is changed only when success code is returned </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when checking was peformed succesfully, -1 if an error occured (failed to check if parameter is registered) </dd></dl>

</div>
</div>
<a class="anchor" id="af547b9808c9ab80ae81356b36846c5e9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_registerKey </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dataType</em> = <code><a class="el" href="fwInstallationProjParam_8ctl.html#a9c246f46e4f1f099cfc5336595d09357">FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>description</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>family</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function allows to register new key for storing projects' parameter in DB. Note: This function must be called before first usage of the key. Note2: If key is already registered for given namespace then function does nothing and returns success code, thus it is possible to call this function multiple times, on different projects with the same result (success) so then user script can proceed without any errors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' (user should define own namespace, it is recommended to use component name as the namespace, using default namespace causes risk of key name clash) </td></tr>
    <tr><td class="paramname">dataType</td><td>(in) Type (description) of data stored under given key, default value: 'text/plain'. Note: It is not the data type in the sense of ctrl variable type (int, string, etc.) - in this sense stored data is always of type 'string' </td></tr>
    <tr><td class="paramname">description</td><td>(in) Key description, optional, default value is empty </td></tr>
    <tr><td class="paramname">family</td><td>(in) Family of key, optional, default value is empty </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when key was registered succesfully or given key already exists in DB, -1 if errors occured (unable to register or verify if key is registered already) </dd></dl>

</div>
</div>
<a class="anchor" id="aee844f5d9d2c06604a03a6e5dcc6206c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_removeKey </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>: NOT IMPLEMENTED YET, DO NOT USE THIS FUNCTION Removes given parameter (key - namespace pair) from DB. </p>
<dl class="section note"><dt>Note</dt><dd>Parameter removal affects all projects that store values under specified key and namespace. After removal all values stored under this parameter by different projects are no longer accessible. </dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when parameter was removed successfully, -1 if an error occured () </dd></dl>

</div>
</div>
<a class="anchor" id="a6896e0e260f1e4880535340c403c0787"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_valueExists </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>exists</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>project</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>host</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function checks if for given key, namespace, project and host a value exists. Note: function will return error if a key doesn't exist (is not registered). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">exists</td><td>(out) Flag that indicates if a value exists in DB for given key, namespace and project, Note: it is changed only when function returns success code </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' </td></tr>
    <tr><td class="paramname">project</td><td>(in) Project name, default value is empty (current project) </td></tr>
    <tr><td class="paramname">host</td><td>(in) Hostname, default value is empty (current host) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when checking was peformed succesfully, -1 if an error occured (failed to check if key in given namespace is registered or failed to check if value is registered) </dd></dl>

</div>
</div>
<a class="anchor" id="a3510b799f949d51a1350b8bd9db3aaa7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_registerKeyValue </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dataType</em> = <code><a class="el" href="fwInstallationProjParam_8ctl.html#a9c246f46e4f1f099cfc5336595d09357">FW_INSTALLATION_PROJ_PARAM_DEFAULT_KEY_TYPE</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>description</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>family</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>project</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>host</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function registers new key and assigns a value. Note: Either this function or fwInstallationProjParam_registerKey must be called before first usage of the key. Note2: If key already exists, for given namespace, registration is skipped and only value is set. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' (user should define own namespace, it is recommended to use component name as the namespace, using default namespace causes risk of key name clash) </td></tr>
    <tr><td class="paramname">dataType</td><td>(in) Type (description) of data stored under given key, default value: 'text/plain'. Note: It is not the data type in the sense of ctrl variable type (int, string, etc.) - in this sense stored data is always of type 'string' </td></tr>
    <tr><td class="paramname">description</td><td>(in) Key description, optional, default value is empty </td></tr>
    <tr><td class="paramname">family</td><td>(in) Family of key, optional, default value is empty </td></tr>
    <tr><td class="paramname">project</td><td>(in) Project name, default value is empty (current project) </td></tr>
    <tr><td class="paramname">host</td><td>(in) Hostname, default value is empty (current host) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when key was registered succesfully or given key already exists in DB, -1 if errors occured (unable to register or verify if key is registered already) </dd></dl>

</div>
</div>
<a class="anchor" id="a7e21f7c42a22cccbd1f4b4c298310f72"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_setValue </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>project</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>host</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the specified value under given key and namespace, for given project, by default the current one. Note: If value did not exist before in DB for specified key, the function registers it under given key and namespace and given project. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">value</td><td>(in) Value to be set under given key and namespace, for given project </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' (user should define own namespace, it is recommended to use component name as the namespace, using default namespace causes risk of key name clash) </td></tr>
    <tr><td class="paramname">project</td><td>(in) Project name, default value is empty (current project) </td></tr>
    <tr><td class="paramname">host</td><td>(in) Hostname, default value is empty (current host) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when value was set successfully, -1 if an error occured (failed to set value or register it if it did not exist before) </dd></dl>

</div>
</div>
<a class="anchor" id="a61bc7b05fe92e9354b0dea24778d4833"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_getValue </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>project</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>host</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function gets the value of project parameter for given namespace, key and project (by default the current one) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">value</td><td>(in) Value of project parameter </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' </td></tr>
    <tr><td class="paramname">project</td><td>(in) Project name, default value is empty (current project) </td></tr>
    <tr><td class="paramname">host</td><td>(in) Hostname, default value is empty (current host) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when value was got successfully, -1 if an error occured (failed to get project parameter as for example the value for given key, namespace and project is not registered in DB or given key is not registered) </dd></dl>

</div>
</div>
<a class="anchor" id="ab302557f31c4ea8606e2459371c50c23"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_removeValue </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>project</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>host</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Removes from DB the value of project parameter for given namespace, key and project (by default the current one) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>(in) Key name </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' </td></tr>
    <tr><td class="paramname">project</td><td>(in) Project name, default value is empty (current project) </td></tr>
    <tr><td class="paramname">host</td><td>(in) Hostname, default value is empty (current host) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when value was removed successfully, -1 if an error occured (given project parameter does not exist in DB, failed to remove project parameter) </dd></dl>

</div>
</div>
<a class="anchor" id="ac62b333430ebe3571006594cd4786834"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationProjParam_getKeyValueMapping </td>
          <td>(</td>
          <td class="paramtype">mapping &amp;&#160;</td>
          <td class="paramname"><em>keyValMapping</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>namespace</em> = <code>FW_INSTALLATION_PROJ_PARAM_DEFAULT_NAMESPACE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>project</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>host</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns all available keys along with their values for given namespace and given project (by default the current one) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">keyValMapping</td><td>(out) Mapping with project parameters (keys and their values) that exist in DB for given namespace and project </td></tr>
    <tr><td class="paramname">namespace</td><td>(in) Namespace, default value: '_default' </td></tr>
    <tr><td class="paramname">project</td><td>(in) Project name, default value is empty (current project) </td></tr>
    <tr><td class="paramname">host</td><td>(in) Hostname, default value is empty (current host) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 when value was got successfully, -1 if an error occured </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a class="anchor" id="a8032f461023707ce5c927fcb96c36936"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string csFwInstallationProjParamLibVersion = &quot;8.4.2&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Version of this library. Used to determine the coherency of all libraries of the installation tool Please do not edit it manually </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
